package com.smppw.analysis.client;

import com.smppw.analysis.application.dto.HeadIndicatorParams;
import com.smppw.analysis.application.dto.HeadIndicatorVO;
import com.smppw.analysis.application.dto.IndicatorParams;
import com.smppw.analysis.application.dto.TrendParams;
import com.smppw.analysis.application.service.CommonService;
import com.smppw.analysis.application.service.PerformanceService;
import com.smppw.common.pojo.vo.ResultVo;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

@RestController
@RequestMapping("/v1/api/fund")
public class FundApi {
    private final CommonService commonService;
    private final PerformanceService performanceService;

    public FundApi(CommonService commonService, PerformanceService performanceService) {
        this.commonService = commonService;
        this.performanceService = performanceService;
    }

    @GetMapping("/indicator")
    public ResultVo<Map<String, Object>> indicator(IndicatorParams params) {
        Map<String, Object> data = this.performanceService.calcIndicators(params);
        return ResultVo.ok(data);
    }

    @GetMapping("/trend")
    public ResultVo<Map<String, Object>> trend(TrendParams params) {
        Map<String, Object> data = this.performanceService.trend(params);
        return ResultVo.ok(data);
    }

    @GetMapping("/head/indicator")
    public ResultVo<HeadIndicatorVO> headIndicator(HeadIndicatorParams params) {
        HeadIndicatorVO indicator = this.commonService.getIndicator(params);
        return ResultVo.ok(indicator);
    }
}
