package com.smppw.analysis.domain.event;

import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.smppw.analysis.domain.gateway.CacheGateway;
import com.smppw.analysis.domain.gateway.CacheVO;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;

@Component
public class CacheEventListener {
    @EventListener(value = {SaveCacheEvent.class})
    public void saveCache(SaveCacheEvent<Object> event) {
        CacheGateway<Object> cacheGateway = event.getCacheGateway();
        CacheVO<Object> cacheTarget = event.getCacheTarget();
        CacheVO.CacheType type = cacheTarget.getType();
        if (type == CacheVO.CacheType.HASH) {
            Object value = cacheTarget.getValue();
            JSONObject entries = JSONUtil.parseObj(JSONUtil.toJsonStr(value));
            cacheGateway.hset(cacheTarget.getKey(), entries);
        } else if (type == CacheVO.CacheType.STR) {
            cacheGateway.set(cacheTarget.getKey(), cacheTarget.getValue());
        }
        cacheGateway.expire(cacheTarget.getKey(), cacheTarget.getTtl(), cacheTarget.getTimeUnit());
    }
}
