package com.smppw.analysis.domain.event;

import com.smppw.analysis.domain.gateway.CacheGateway;
import com.smppw.analysis.domain.gateway.CacheVO;
import org.springframework.context.ApplicationEvent;

public class SaveCacheEvent<T> extends ApplicationEvent {
    private final CacheVO<T> cacheTarget;
    private final CacheGateway<Object> cacheGateway;

    public SaveCacheEvent(Object source, CacheGateway<Object> cacheGateway, CacheVO<T> cacheTarget) {
        super(source);
        this.cacheTarget = cacheTarget;
        this.cacheGateway = cacheGateway;
    }

    public CacheVO<T> getCacheTarget() {
        return cacheTarget;
    }

    public CacheGateway<Object> getCacheGateway() {
        return cacheGateway;
    }
}
