package com.smppw.analysis.domain.gateway;

import lombok.*;

import java.util.concurrent.TimeUnit;

@Setter
@Getter
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class CacheVO<V> {
    private CacheType type;
    private String key;
    private V value;
    private long ttl;
    private TimeUnit timeUnit;

    // 仅支持str、hash
    public enum CacheType {
        STR, HASH
    }
}
